/*********************************************************************
*    Ŀ:MG82F6D16-DEMO
*			԰ʹ MG82F6Dxx	SSOP28 EV Board (TH189A)
*			CpuCLK=12MHz, SysCLK=12MHz
*	
*			IOģʽ
*	ע
*
*    ʱ:
*    ޸־:
*    
**********************************************************************/
#define _MAIN_C

#include <Intrins.h>
#include <Absacc.h>

#include <Stdio.h>  // for printf

#include ".\include\REG_MG82F6D16.H"
#include ".\include\Type.h"
#include ".\include\API_Macro_MG82F6D16.H"
#include ".\include\API_Uart_BRGRL_MG82F6D16.H"


/*************************************************
*ϵͳʱSysClk (MAX.50MHz)
*ѡ: 
*	11059200,12000000,
*	22118400,24000000,
*	29491200,32000000,
*	44236800,48000000
*************************************************/
#define MCU_SYSCLK		12000000
/*************************************************/
/*************************************************
*CPUʱ CpuClk (MAX.25MHz)
*	1) CpuCLK=SysCLK
*	2) CpuClk=SysClk/2
*************************************************/
#define MCU_CPUCLK		(MCU_SYSCLK)
//#define MCU_CPUCLK		(MCU_SYSCLK/2)

#define TIMER_1T_1ms_TH	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(1000000)))) /256) 			
#define TIMER_1T_1ms_TL	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(1000000)))) %256)

#define TIMER_12T_1ms_TH	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(12000000)))) /256) 			
#define TIMER_12T_1ms_TL	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(12000000)))) %256)

#define LED_G_0		P22
#define LED_R		P24
#define LED_G_1		P26


/*************************************************
* :        void DelayXus(u16 xUs)
*:   	ʱ,λΪus
*:     u8 Us -> *1us  (1~255)
*ز:     
*************************************************/
void DelayXus(u8 xUs)
{
	while(xUs!=0)
	{
#if (MCU_CPUCLK>=11059200)
		_nop_();
#endif
#if (MCU_CPUCLK>=14745600)
		_nop_();
		_nop_();
		_nop_();
		_nop_();
#endif
#if (MCU_CPUCLK>=16000000)
		_nop_();
#endif

#if (MCU_CPUCLK>=22118400)
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
#endif
#if (MCU_CPUCLK>=24000000)
		_nop_();
		_nop_();
#endif		
#if (MCU_CPUCLK>=29491200)
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
#endif
#if (MCU_CPUCLK>=32000000)
		_nop_();
		_nop_();
#endif

		xUs--;
	}
}

/*************************************************
* :        void DelayXms(u16 xMs)
*:     ʱ,λΪms
*:     u16 xMs -> *1ms  (1~65535)
*ز:     
*************************************************/
void DelayXms(u16 xMs)
{
	while(xMs!=0)
	{
		CLRWDT();
		DelayXus(200);
		DelayXus(200);
		DelayXus(200);
		DelayXus(200);
		DelayXus(200);
		xMs--;
		
	}
}


/***********************************************************************************
* :   void InitPort(void)
*:   IO
*:   
*ز:     
*************************************************************************************/
void InitPort(void)
{
	PORT_SetP1AInputOnly(BIT0|BIT1);				// P10,P11 Ϊģ
	PORT_SetP1OpenDrainPu(BIT5);					// P15 Ϊ©ģʽ
	PORT_SetP1OpenDrain(BIT6);						// P16 Ϊ©ģʽ
	PORT_SetP1PushPull(BIT7);						// P17 Ϊģʽ

	//PORT_SetP2AInputOnly(BIT2|BIT4);				// P22,P24 Ϊģ
	//PORT_SetP2OpenDrainPu(BIT2|BIT4);				// P22,P24 Ϊ©ģʽ
	//PORT_SetP2OpenDrain(BIT2|BIT4);				// P22,P24 Ϊ©ģʽ
	PORT_SetP2PushPull(BIT2|BIT4|BIT6);				// P22,P24,P26 Ϊģʽ

	//PORT_SetP3InputOnly(BIT3);					// P33 Ϊ
	//PORT_SetP3OpenDrain(BIT3|BIT4|BIT5);			// P33,P34,P35 Ϊ©ģʽ
	PORT_SetP3QuasiBi(BIT0|BIT1|BIT3|BIT4|BIT5);	// P30,P31,P33,P34,P35 Ϊ׼˫ģʽ
	//PORT_SetP3PushPull(BIT5);						// P35 Ϊģʽ

	//PORT_SetP4AInputOnly(BIT4|BIT5);				// P44,P45 Ϊģ
	//PORT_SetP4OpenDrainPu(BIT4|BIT5);				// P44,P45 Ϊ©ģʽ
	//PORT_SetP4OpenDrain(BIT4|BIT5);				// P44,P45 Ϊ©ģʽ
	//PORT_SetP4PushPull(BIT4|BIT5);				// P44,P45 Ϊģʽ

	//PORT_SetP6AInputOnly(BIT0|BIT1);				// P60,P61 Ϊģ
	//PORT_SetP6OpenDrainPu(BIT0|BIT1);				// P60,P61 Ϊ©ģʽ
	PORT_SetP6OpenDrain(BIT0|BIT1);					// P60,P61 Ϊ©ģʽ
	//PORT_SetP6PushPull(BIT0|BIT1);				// P60,P61 Ϊģʽ
}




/***********************************************************************************
* :   void InitSystem(void)
*:   ϵͳʼ
*:   
*ز:     
*************************************************************************************/
void InitSystem(void)
{
	
	InitPort();

}



void main()
{

    InitSystem();
					
	LED_G_0=0;LED_G_1=0;LED_R=0;
	DelayXms(1000);
	LED_G_0=1;LED_G_1=1;LED_R=1;

					
    while(1)
    {
		LED_G_0=0;
		DelayXms(200);
		LED_G_0=1;
		LED_G_1=0;
		DelayXms(200);
		LED_G_1=1;
		LED_R=0;
		DelayXms(200);
		LED_R=1;
    }
}


